# Oppsett for utvikling av dashboard
Merk: Vi bruker PyCharm som Python IDE. Instruksjonenen baserer seg på den IDE-en. 

## Følgende programvare kreves:

- Docker(Docker Desktop anbefales)
- Python-editor(Pycharm anbefales)

## Instruksjoner:

1. Åpne terminal i prosjekt-mappen og kjør følgende kommando:  “docker-compose up”
2. Åpne Docker Desktop og start CLI-en til den tilhørende containeren:
- Installer JSON-plugin i Docker-containeren ved å kjøre kommandoen: “grafana-cli plugins install simpod-json-datasource” 
- Restart containeren. 
3. Åpne prosjektet i en python-editor
4. Sett opp et venv(virtual enviroment) i editoren:
-  Gå til Preferanser/preferences og trykk på "Python Interpreter" som ligger under Project
-  Velg "Python interpreter" og trykk "Show All..."
-  Trykk deretter på "+"-ikonet nede til venstre 
-  Legg til en "Virtualenv Environment", filen skal ligge i Prosjekt-filen og velg en versjon av Python(vi bruker per dags dato Python 3.9) 
5. Kjør følgende kommando i den (venv)- terminalen("Terminal" nederst i prosjekt-vinduet ):
- "Pip install poetry" og "Poetry install"
6. Sett opp en run-konfigurasjon i Python
- Velg "Add configuration..." 
- Trykk "+" oppe til venstre og velg "Python"
- Script path:  Path-en til fil som skal kjøres 
- Python interpreter: samme interpreter som ble satt opp i punkt 4. 
- Working directory-pathen skal ikke gå lengre enn ".../prototype/"
7. Spesifiser detaljer om databasen du skal koble til i connections.yaml-filen.
- Databasen trenger brukernavn, passord og IP-adresse.
8. Kjør \__main__( det er hovedfilen som starter API-et)
9. Åpne nettleser og naviger til: "localhost:3000"
    - Passord og brukernavn til Grafana:  “admin”
10. Naviger til tannhjulet på menyen til venstre og velg "Data Sources"
11. Legg til Data Source og velg JSON
    - Koble til URL: “host.docker.internal:8000” og velg som standard
12. Naviger til pluss-knappen på venstre side av nettsiden og trykk 'Import'
13. Velg "Upload JSON file"  og deretter ønsket mal. 

## Ved bruk av en lokal-server som har Microsoft Authenticator:

For å koble databasen til fra API-et til  Grafana trenger man en bruker med brukernavn og passord som skal defineres i conncetions.yaml. 
Det er også nødvendig å åpne den lokale databasen for å bli aksessert gjennom internett. Dette gjøres i SQL Server Configuration Manager. 
Kilde for å muliggjøre TCP/IP i sql server: http://www.manifold.net/doc/mfd9/enable_tcp_ip_for_sql_server.htm  
Legg merke til at dette fungerer bare ved en enkelt instanse av "SQL Server Express". Den deaktiverer dynamiske porter  i SQL Server og tvinger den til å bruke port "1433".

# Aktivere TCP/IP for SQL Server(kort oppsummert): 

1. Åpne "SQL Server Configuration Manager" og utvid " SQL Server Network Configuration" og klikk på "Protocols for SQLEXPRESS"
2. Høyre-klikk på "TCP/IP" og trykk "enable".
3. Dobbel-klikk på " TCP/IP", velg "IP Adresses" fra menyen i toppen. 
4. Nderst fra menyen vil det stå "IPAll"-seksjon med to underkategorier, dobbel-klikk på "TCP Port" og skriv inn "1433".
5. Trykk "Apply" og så  "OK"
6. Restart serveren. 
