import ArgosAnalysePlatform.plugins.analysis as analysis


def test_cumulative_percentage():
    inp = [1, 2, 3, 4]

    assert analysis._generate_cumulative_percentage(inp) == [10, 30, 60, 100]


def test_fill_partial_axis():
    inp = [(0, 1), (2, 3), (4, 5)]

    assert analysis._fill_partial_axis(inp) == [(0, 1), (1, 0), (2, 3), (3, 0), (4, 5)]


def test_generate_xy_from_db(monkeypatch):
    def mocked_query(*args):
        return {0: [("argosname", 0, 1), ("argosname", 2, 3), ("argosname2", 4, 5)]}

    monkeypatch.setattr(analysis, "_query_pareto", mocked_query)

    result = analysis._generate_pareto_xy_from_db(0, 0, 0, 0)

    expected_result = {
        "argosname": {0: ((0, 1, 2), (1, 0, 3))},
        "argosname2": {0: ((1, 2, 3, 4), (0, 0, 0, 5))},
    }

    assert dict(result) == expected_result


def test_find_most_valuable_change():
    inp_y = [5, 6, 5, 0, 5, 5]
    current = 0

    result = analysis.find_most_valuable_change(inp_y, current)

    assert result == 3


def test_find_most_valuable_change_not_overruns():
    inp_y = [5, 6, 5, 5, 5, 6]
    current = 0

    result = analysis.find_most_valuable_change(inp_y, current)

    assert result == 4
